/* A simple server in the internet domain using TCP
   The port number is passed as an argument */
/*help to construct this is taken from google*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>

void error(const char *msg)
{
    perror(msg);
    exit(1);
}

int main(int argc, char *argv[])
{
     int sockfd, newsockfd, portno;
     socklen_t clilen;  		     		//unsingned int
     char buffer[256];

     
     struct sockaddr_in serv_addr, cli_addr; 		//strustures inbuuilt for comm
     int n;
     if (argc < 2)					//valid input need to provide port for communication
	{
        fprintf(stderr,"ERROR, no port provided\n");
        exit(1);
        }
     

     sockfd = socket(AF_INET, SOCK_STREAM, 0);		//creating socket//TCP forstrem??UDP Datagram
     if (sockfd < 0) 					//ERRor in creating socket
	{       
	error("ERROR opening socket");
	}
     bzero((char *) &serv_addr, sizeof(serv_addr));	//bzero(char *s....s Points to a buffer that zeros are copied into.
     portno = atoi(argv[1]);				//converts string to integer type

     
     serv_addr.sin_family = AF_INET;			//entering values to structure 
     serv_addr.sin_addr.s_addr = INADDR_ANY;
     serv_addr.sin_port = htons(portno);	//converts host byte order retuns value in TCP/IP network byte order PORTS are callrd using network byte order convention
     

     if (bind(sockfd, (struct sockaddr *) &serv_addr,sizeof(serv_addr)) < 0) 
	{              
	error("ERROR on binding");
	}
     listen(sockfd,5);					//listen for connection req with que length 5
     

     clilen = sizeof(cli_addr);
     newsockfd = accept(sockfd , (struct sockaddr *) &cli_addr,&clilen);	//New socket created for accept of data
     if (newsockfd < 0) 
	{          
	error("ERROR on accept");			//ERRor on accept
	}     
	
	
     bzero(buffer,256);					//read and write
     n = read(newsockfd,buffer,255);
     if (n < 0) error("ERROR reading from socket");
     printf("Here is the message: %s\n",buffer);
     n = write(newsockfd,"I got your message",18);
     if (n < 0) error("ERROR writing to socket");
     close(newsockfd);
     close(sockfd);
     return 0; 
}
