#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <netdb.h> 
#include <iostream>
#include<ctime>
#include<cmath>
#define MAX_SIZE 256
#define NAME_MAX 40

typedef unsigned long long ll;

using namespace std;
void error(const char *msg)
	{
    perror(msg);
    exit(0);
	}
	
	
	
ll keygen(ll,ll,ll);
void encrypt(char *buffer,ll KEY);	
void decrypt(char *buffer, ll KEY);
	

int main(int argc, char *argv[])
	{
    int sockfd, portno, n;
    struct sockaddr_in serv_addr;
    struct hostent *server;


    char buffer[MAX_SIZE];
    char file[20];
    char line_input[200];
	int k=0,t=0,j=0;
	char filebuffer[6024];
    if (argc < 2)
		{
		fprintf(stderr,"usage %s hostname \n", argv[0]);
        exit(0);
		}
    portno = 121218;										//predifining port

    
    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    if (sockfd < 0) 
		{        
		error("ERROR opening socket");
    	}


    server = gethostbyname(argv[1]);
    if (server == NULL) 
		{
        fprintf(stderr,"ERROR, no such host\n");
        exit(0);
		}
	
	
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    bcopy((char *)server->h_addr,       (char *)&serv_addr.sin_addr.s_addr,        server->h_length);
    serv_addr.sin_port = htons(portno);
    

    if (connect(sockfd,(struct sockaddr *) &serv_addr,sizeof(serv_addr)) < 0) 
		{        
		error("ERROR connecting");
		}


    //connection is established now both user can exchange information
	//presentation on terminal  
	
	system("clear");
	cout<<"\t\t\t**CONNECTING**"<<endl;
	for (int i=0;i<6;i++)
	{
		sleep(1);
		cout<<"\t\t\t\t."<<endl;
	}
	
	//receiving name of server
	
	char x[NAME_MAX];
	bzero(x,NAME_MAX);
	n = read(sockfd,x,(NAME_MAX-1));  						// reading message in to buffer
	if (n < 0) 		
		{
		cout<<"\n ERROR reading from socket";
		} 
	cout<<"\n\n\t\t\t**CONNECTION ESTABLISHED**\n";
	printf("You are connected to %s ",x);
	
	//self details
	char name[NAME_MAX];
	bzero(name,NAME_MAX);
	cout<<"\n Enter your name : ";
	gets(name);
	n = write(sockfd,name,strlen(name));					// sending name to client...  
   	if (n < 0) 
	{
		cout<<"\n ERROR writing to socket";
	}
	
	//waiting for response of server
	cout<<"\nWAITING FOR RESPONSE OF "<<x<<endl;  
	char ans[2];
	n=read(sockfd,ans,1);
	if (n < 0) 		
	{
		cout<<"\n ERROR reading from socket";
	} 
	
	//if server refuses access
	if ( (ans[0]=='n')||(ans[0]=='N') )
	{
		printf("%s refused your request to connect",x);
		cout<<"\n\t\t\t**CONNECTION DIFFUSED**"<<endl; 
		close(sockfd);
			return 0;
	}
	
	//if server allow to access
	else if ( (ans[0]=='y')||(ans[0]=='Y') )
	{
			//presenting on terminal
			cout<<x<<" accepted your request"<<endl;
			cout<<"\t\t\t**PROCESSING**"<<endl;
			for (int i=0;i<4;i++)
			{
				sleep(1);
				cout<<"\t\t\t\t."<<endl;
			}
			system("clear");
			
			//key exchange begins
			cout<<"\n\t\t\t**YOU ARE CONNECTED TO "<<x<<" **"<<endl;
			cout<<"\t\t\t**KEY EXCHANGE BEGINS\n\t\t\t  FOR SECURE CONVERSATION**"<<endl;

			//receiving safeprime from the listener
			ll safeprime[1];
			n = read(sockfd,safeprime,8); //receiving the safeprime 
			if (n <0)
			{
				cout<<"\n ERROR reading from socket";
			}
			cout<<"\nSafeprime received is  "<<*safeprime<<endl;
			
			//listening to the number produced by listener using his produced random number, safeprime and generator
			ll temp_key_received[1];
			n = read(sockfd,temp_key_received,8); // receiving temp_key generated by listener
			if (n <0)
			{
				cout<<"\n ERROR reading from socket";
			}
			cout<<"\ntemp key recieved is"<<*temp_key_received<<endl;


			//generating random  number for user that is not shared
			ll rand_num;
			srand(time(0));   //giving ceed value for rand function to be time
			srand(rand());    //again giving ceed value for rand 
			rand_num=rand();
			
			//sharing the (generator^rand_num)mod(safeprime)  which is used to produce final secret_key key	
			ll key1;
			key1=keygen(*safeprime,rand_num,2); //invoking function to calculate the required above mentioned function
			ll *temp;
			temp=&key1;
			n = write(sockfd,temp,8);  //sending number generated to listener..
			if (n < 0) 
				{cout<<"\n ERROR writing to socket";}
			sleep(1);

			//producing the final key using (temp_key_received^rand_num)mod(p)....this secret_key will be used for further conversation
		 
			ll secret_key;
			secret_key=keygen(*safeprime,rand_num,*temp_key_received);
			cout<<"\n YOUR SECRET KEY FOR THIS SESSION IS : \n\t\t\t\t**"<<secret_key<<"**\n\n"<<endl;
			sleep(1);
			cout<<"\t\t\tGETTING READY FOR SESSION"<<endl;
			for (int i=0;i<5;i++)
			{
				sleep(1);
				cout<<"\t\t\t."<<endl;
			}
			system("clear");
			
			
			//data transfer begins from here..
			cout<<"you are connected to "<<x<<endl;
			cout<<"DO YOU WANT TO SEND ANY FILE TO (y/n) "<<x<<"  ";
			bzero(ans,2);
			gets(ans);
			n=write(sockfd,ans,1);  //sending answer to client
			if (n < 0) 
			{
				cout<<"\n ERROR writing to socket";
			}
			
			
			if ((ans[0]=='y')||(ans[0]=='Y'))
			{
					cout<<" please enter the valid name of file to be sent"<<endl;
					gets(file);
					FILE *input;
					input=fopen(file,"r");
					if(input==NULL) 
					{
						cout<<"Could not read file\n";
						cout<<"incorrect file "<<endl;
						//closing the sockets
						close(sockfd);
						return 0; 
					}
					
					fgets(line_input,199,input);	
					while(!feof(input)) 
					{
						j=strlen(line_input);
						while(k!=j)
						{
							filebuffer[t++]=line_input[k++];
						}
						k=0;
						fgets(line_input,199,input);	
					}
					fclose(input);
					encrypt(filebuffer,secret_key);
					n = write(sockfd,filebuffer,6024); // sending message to listener
					if (n < 0) 
					{
						cout<<"\n ERROR writing to socket";
					}
					cout<<"FILE SUCCESSFULLY SENT"<<endl;
			}
			
			cout<<"ASKING "<<x<<" IF HE WANTS TO SEND ANY FILE"<<endl;
			cout<<"WAITING FOR RESPONSE OF "<<x<<endl;  
			bzero(ans,2);
			n=read(sockfd,ans,1);
			if (n < 0) 		
			{
				cout<<"\n ERROR reading from socket";
			} 
			
			if ((ans[0]=='n')||(ans[0]=='N'))
			{
				cout<<x<<" don't want to share file"<<endl;
				cout<<"begin to chat"<<endl;
				sleep(1);
				system("clear");
				cout<<"YOU ARE CONNECTED TO "<<x;
			}
			
			if ((ans[0]=='y')||(ans[0]=='Y'))
			{
					cout<<x<<" wants to share file with you"<<endl;
					FILE *output;
					bzero(file,20);
					cout<<"enter the name of file by which it is to be saved"<<endl;
					gets(file);		
					output=fopen(file,"w+");
					if(output==NULL) 
					{
						cout<<"Error in creating output file\n";
						//closing the sockets
						close(sockfd);
						return 0;
					}	
					bzero(filebuffer,6024);
					n = read(sockfd,filebuffer,6024);// reading message in to buffer
					if (n < 0) 
					{
						cout<<"\n ERROR reading from socket";
					}
					decrypt(filebuffer,secret_key);
					fprintf(output,"%s",filebuffer);
					fclose(output);
					cout<<"file successfully received and saved as"<<file<<endl;
					cout<<"now you may begin to chat"<<endl;
					sleep(1);
					system("clear");
			}
			
				
			//displaying instruction 
			FILE *instruction;
			char linestr[91];
			instruction=fopen("instruction.txt","r");
			fgets(linestr,70,instruction);
			while(!feof(instruction))
			{
				cout<<linestr;
				fgets(linestr,70,instruction);
			}
			fclose(instruction);
			
			
			sleep(20);       //delaying time to read instruction
				
			//presenting on terminal
			system("clear");
			cout<<"YOU"<<endl;
			sleep(1);
			cout<<"\n\tMAY"<<endl;
			sleep(1);
			cout<<"\n\t\tBEGIN"<<endl;
			sleep(1);
			cout<<"\n\t\t\tto"<<endl;
			sleep(1);
			cout<<"\n\t\t\t\tchat"<<endl;
			sleep(1);
			cout<<"\n\t\t\t\t\twith"<<endl;
			sleep(1);
			cout<<"\n\t\t\t\t\t\t"<<x<<endl;
			sleep(2);
			system("clear");
			cout<<"YOU MAY BEGIN TO CHAT WITH "<<x<<endl;
		
			bzero(buffer,MAX_SIZE);	
			while(1) 
			{
			
					//sending the message  
				
					cout<<name<<" :";
					bzero(buffer,MAX_SIZE);  //char buffer array defined  to read and write message in to that...bzero to empty whole of the array 
					gets(buffer); // message being stored into buffer
					cout<<endl;
					encrypt(buffer,secret_key);  // message getting encrypted using secret_key
					//cout<<"\nSENT ENCRYPTED MESSAGE"<<buffer;

					n = write(sockfd,buffer,255); // sending message to listener
					if (n < 0) 
					{
						cout<<"\n ERROR writing to socket";
					}
					decrypt(buffer,secret_key);
					if ((buffer[0]=='b') && (buffer[1]=='y') && (buffer[2]=='e')) 
					{
						break;
					} //if user sends bye thn session ends
				
				
					// reading the message	     
			   
					bzero(buffer,MAX_SIZE);// again emptying the array buffer so that message could be read in to it
					n = read(sockfd,buffer,(MAX_SIZE-1));// reading message in to buffer
					if (n < 0) 
					{
						cout<<"\n ERROR reading from socket";
					}
					// cout<<"\nRECEIVED ENCRYPTED MESSAGE"<<buffer;
					decrypt(buffer,secret_key);  //decrypting received message using secret key 
					cout<<x<<" :"<<buffer<<endl;//displaying the message received
					if ((buffer[0]=='b') && (buffer[1]=='y') && (buffer[2]=='e')) 
					{
						break;
					} //if user receives bye thn session ends	
			}  
		
		
			cout<<"\n\n SESSION ENDED\n\n";
		
			//closing the sockets

			close(sockfd);
			return 0; 
	}
}




	//function to generate keys

	ll keygen(ll safeprime,ll rand_num, ll generator)

	{
		ll p=1,j;
		while(rand_num!=0)
		{
			j=generator%safeprime;
			generator=j*j;
			if (rand_num&1){p=(p*j)%safeprime;}
			rand_num=rand_num>>1; // shifting bits of the number by 1 bit to the right
		}
		
		return p;
	}
				
		
//////////////////////////////////////////////////////////////////function to encrypt message


void encrypt(char *buffer,ll KEY)

{   
		int count,i,a,b,c,message_length;
		char intiallisation_vector[1024];
			 
		message_length=strlen(buffer);
		a=(message_length*8)/128; // a= number of loops that are perfect for decryption(loops which have 16 byte or 128 bits message
		b=((message_length*8)-(a*128));//b=number of bits which are part of last loop(or incompleted loop) 
		c=(128-b)/8;                 //c=number of bytes required to complete that last loop
		message_length=strlen(buffer);
				
		 for(i=message_length; i<(message_length+c); i++){
                       buffer[i]=1;}
             
		
		ll temp;
		temp=KEY;
		for(i=0; i<16; i++)
		{
			intiallisation_vector[i]=i;
		}


		count =0;
		for(i=0; i<16; i++)
		{
				buffer[i]=buffer[i]^intiallisation_vector[i];
				buffer[i]=buffer[i]^KEY;
				KEY=KEY>>8; count++;
				if(count==8)
				{
					KEY=temp; count=0;
				}
			
		 }

		 for(i=16;  i<(message_length+c) ; i++)
		 {
				 buffer[i]=buffer[i-16]^buffer[i];
				 buffer[i]=buffer[i]^KEY;
				   KEY=KEY>>8; count ++;
				 if(count==8)
				 {
					 KEY=temp; count=0;
				 }
		 }
		 bzero(&buffer[message_length],c+1);
}
            
	
	
			
	
	
	
///////////////////////////////////////////////////////function to decrypt message	
	
	
	
void decrypt(char *buffer, ll KEY)
{          
		int message_length,a,b,i,c;
		char intiallisation_vector[1024];
		
		//defining initialisation vector
		
		message_length=strlen(buffer);
		a=(message_length*8)/128; // a= number of loops that are perfect for decryption(loops which have 16 byte or 128 bits message
		b=((message_length*8)-(a*128));//b=number of bits which are part of last loop(or incompleted loop) 
		c=(128-b)/8;                 //c=number of bytes required to complete that last loop
		
		for(i=message_length; i<(message_length+c); i++){
                       buffer[i]=1;}
		
		
		ll temp;
		temp=KEY;
		for(i=0; i<16; i++)
		{
			intiallisation_vector[i]=i;
		}


		//decrypting the last part of message as it was encrypted at last
		
		int r=0;
			
		for(i=(message_length+c-1); i>15; i--)
		{	
				KEY=temp;
				r=i%8;
				KEY=KEY>>(r*8);
				buffer[i]=buffer[i]^KEY;
				buffer[i]=buffer[i]^buffer[i-16];
		}

		//decrypting the initial part of message    
		for(i=15;  i>=0; i--)
		{
				KEY=temp;
				r=i%8;
				KEY=KEY>>(r*8);
				buffer[i]=buffer[i]^KEY;
				buffer[i]=buffer[i]^intiallisation_vector[i];
		}
		bzero(&buffer[message_length],c+1);
}

